/*
 *  old addressbook window
 */

async function abwindow_legacy(w) {
debug('Legacy addressbook loaded, try adding menu items');

  w.checkBookType=(sd)=>{
    let hide=sd?sd.isMailList:false;
    let p=sd.dirPrefId;
    if (!prefs.hasOwnProperty(p+'.down')) hide=true;
    w.document.querySelectorAll("[class=absDown]").forEach(e => {e.hidden = hide; });
    if (prefs['noupload']) hide=true;
    w.document.querySelectorAll("[class=absUp]").forEach(e => {e.hidden = hide; });
  }
  let tm=w.document.getElementById('taskPopup');
  let sep=w.document.getElementById('prefSep');
debug('Addressbook '+tm+' '+sep);

  // Task menu entries
  let up=sep.previousSibling.cloneNode();
  up.label=strings['upload_title'];
  up.removeAttribute('accesskey');
  up.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_upload', '');");
  if (prefs['noupload']) up.hidden=true;
  let down=sep.previousSibling.cloneNode();
  down.label=strings['download_title'];
  down.removeAttribute('accesskey');
  down.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_download', '');");
  tm.insertBefore(down, sep);
  tm.insertBefore(up, sep);

  // context menu entries
  let dtc=w.document.getElementById('dirTreeContext');
//onpopupshowing="updateDirTreeContext();"
  let ops=dtc.getAttribute('onpopupshowing');
debug('dirTreeContext onpopupshowing='+ops);
  dtc.setAttribute('onpopupshowing', ops+' checkBookType(getSelectedDirectory());');
/*
document.getElementById('dirTreeContext-abs-upload').disabled=iml;
document.getElementById('dirTreeContext-abs-download').disabled=iml;
*/
  let d=w.document.getElementById('dirTreeContext-delete');
  let sep2=d.previousSibling.cloneNode();
  sep2.classList.add('absDown');
  let ups=d.cloneNode();
  ups.id='dirTreeContext-abs-upload';
  ups.className='absUp';
  ups.label=strings['addressbookssync_upload'];
  ups.removeAttribute('accesskey');
  ups.removeAttribute('command');
  ups.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_upload', \
      JSON.stringify({ uri: getSelectedDirectoryURI() }) );");
  if (prefs['noupload']) ups.hidden=true;
  let downs=d.cloneNode();
  downs.id='dirTreeContext-abs-download';
  downs.className='absDown';
  downs.label=strings['addressbookssync_download'];
  downs.removeAttribute('accesskey');
  downs.removeAttribute('command');
  downs.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_download',\
      JSON.stringify({ uri: getSelectedDirectoryURI() }) );");
  dtc.insertBefore(ups, d);
  dtc.insertBefore(downs, d);
  dtc.insertBefore(sep2, d);

  // toolbar buttons
  stylesheets(w);
  let toolbox=w.document.getElementById("ab-toolbox");
  let toolbar=w.document.getElementById("ab-bar2");
  let btn=button('de-ggbs-abs-UploadIcon', "upload_title", 'upload', w.document, toolbox, toolbar);
  if (prefs['noupload']) btn.hidden=true;
  button('de-ggbs-abs-DownloadIcon', "download_title", 'download', w.document, toolbox, toolbar);

  return;
}
function stylesheets(win) {
  if (!win.document.documentElement) {
debug('delay loading of stylesheet')
    win.setTimeout(stylesheets, 500, win);
    return;
  }
	let link=win.document.createElement("link");
	link.setAttribute("rel", "stylesheet");
  link.setAttribute("href", "chrome://addressbookssync/content/skin/abs_addressbook.css");
  win.document.documentElement.appendChild(link);
debug('stylesheet loaded into '+win.location);
}
function button(id, label, direction, doc, tbox, tbar) {
	let btn=doc.createXULElement("toolbarbutton");
	btn.setAttribute("id", id);
	btn.setAttribute("class", "toolbarbutton-1");
	let l=gContext.extension.localeData.localizeMessage(label);
	btn.setAttribute("label", l);
	btn.setAttribute("tooltiptext", l);
	btn.setAttribute("removable", "true");
	btn.setAttribute("oncommand", "Services.obs.notifyObservers(null, 'abs_"+direction+"', '');");
	tbox.palette.appendChild(btn);	//append to palette
	let windowURL =
		"chrome://messenger/content/addressbook/addressbook.xhtml";
	tbar.currentSet = Services.xulStore.getValue(windowURL, "ab-bar2", "currentset");
	tbar.setAttribute("currentset", tbar.currentSet);
debug('button installed');
  return btn;
}

/****************************************************************************/

/*
 *  new addressbook tab
 */

async function abwindow(w) {
debug('New addressbook loaded, try adding menu items window='+w+' '+w.docShell.outerWindowID);

  let booksList = w.document.getElementById("books");
  if (!booksList) {
debug('  addressbook window not fully loaded, wait...');
    w.setTimeout(abwindow, 100, w, 1);
    return;
  }
  booksList.absUpDownloadSelected=(direction)=>{
//console.log('booksList.'+direction+' '+booksList.selectedIndex);
    let row = booksList.rows[booksList.selectedIndex];
    if (row.classList.contains("bookRow")) {  //only books
      Services.obs.notifyObservers(null, 'abs_'+direction,
        JSON.stringify({ uid: row.dataset.uid}) );
    } //else console.log('no book selected, probably a list');
  }
  w.addEventListener('contextmenu', (event)=>{
//    console.log('context on '+event.target.className);
    let hide=event.target.className!='bookRow-name';  //hide lists
    let row=event.target.parentNode.parentNode;
    let p=u2i[row.dataset.uid];
    if (!prefs.hasOwnProperty(p+'.down')) hide=true;
    //if (event.target.parentNode.parentNode.classList.contains('carddav')) hide=true;
    this.document.getElementById('bookContextABSdownload').hidden=hide;
    if (prefs['noupload']) hide=true;
    this.document.getElementById('bookContextABSupload').hidden=hide;
  });

  let tb=w.document.getElementById('toolbox');
  let item=w.document.getElementById('toolbarCreateContact');
//<xul:toolbarbutton id="toolbarCreateContact" class="toolbarbutton-1"
//   data-l10n-id="about-addressbook-toolbar-new-contact" oncommand="createContact();"
//   label="Neuer Kontakt" disabled="true">
//    <xul:image class="toolbarbutton-icon" label="Neuer Kontakt"/>
//    <xul:label class="toolbarbutton-text" crop="right" flex="1" value="Neuer Kontakt"/>
//</xul:toolbarbutton>
  let down=item.cloneNode(true);
  down.id='toolbarABSdownload';
  down.removeAttribute('data-l10n-id');
  down.label=strings['download_title'];
  down.firstChild.label=strings['download_title'];
  down.firstChild.nextSibling.value=strings['download_title'];
  down.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_download', '');");
  down.disabled=false;
  down.style.listStyleImage="url(\"chrome://addressbookssync/content/skin/download.svg\"";
  tb.firstChild.appendChild(down);
  let up=item.cloneNode(true);
  up.id='toolbarABSupload';
  up.removeAttribute('data-l10n-id');
  up.label=strings['upload_title'];
  up.firstChild.label=strings['upload_title'];
  up.firstChild.nextSibling.value=strings['upload_title'];
  up.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_upload', '');");
  up.disabled=false;
  up.style.listStyleImage="url(\"chrome://addressbookssync/content/skin/upload.svg\"";
  if (prefs['noupload']) up.hidden=true;
  tb.firstChild.appendChild(up);

  let bc=w.document.getElementById('bookContext');
  item=w.document.getElementById('bookContextProperties');
//<xul:menuitem id="bookContextProperties" data-l10n-id="about-addressbook-books-context-properties"
//  oncommand="booksList.showPropertiesOfSelected();" label="Eigenschaften">
//    <xul:label class="menu-text" crop="right" aria-hidden="true" value="Eigenschaften"/>
//    <xul:hbox class="menu-accel-container" aria-hidden="true"><xul:label class="menu-accel"/>
//    </xul:hbox>
//</xul:menuitem>
  down=item.cloneNode(true);
  down.id='bookContextABSdownload';
  down.removeAttribute('data-l10n-id');
  down.label=strings['addressbookssync_download'];
  down.setAttribute('oncommand', "booksList.absUpDownloadSelected('download');");
  bc.appendChild(down);

  up=item.cloneNode(true);
  up.id='bookContextABSupload';
  up.removeAttribute('data-l10n-id');
  up.label=strings['addressbookssync_upload'];
  up.setAttribute('oncommand', "booksList.absUpDownloadSelected('upload');");
  bc.appendChild(up);
}
